#include <asm/io.h>
#include <dma.h>

static void set_dma_page(unsigned int dma, char page);

/*   DMA (  DREQ) */
void enable_dma(unsigned int dma)
{
	if( dma <= 3 ) outb(dma, 0x0a);
	else outb(dma & 3, 0xd4);
}

/*   DMA (  DREQ) */
void disable_dma(unsigned int dma)
{
	if( dma <= 3 ) outb(dma | 4, 0x0a);
	else outb((dma & 3) | 4, 0xd4);
}

/*    DMA */
void set_dma_mode(unsigned int dma, char mode)
{
	if( dma <=3 ) outb(dma | mode, 0x0b);
	else outb((dma & 3) | mode, 0xd6);
}

/*     DMA */
void set_dma_page(unsigned int dma, char page)
{
	switch( dma )
	{
		case 0: outb(page,0x87); break;
		case 1: outb(page,0x83); break;
		case 2: outb(page,0x81); break;
		case 3: outb(page,0x82); break;
		case 5: outb(page,0x8b); break;
		case 6: outb(page,0x89); break;
		case 7: outb(page,0x8a); break;
	}
}

/*      -  DMA */
void set_dma_addr(unsigned int dma, unsigned int addr)
{
	set_dma_page(dma, addr>>16);
	if( dma <= 3 )
	{
		outb(addr & 0xff, (dma << 1) + 0x00);
		outb((addr >> 8) & 0xff, (dma << 1) + 0x00);
	}
	else
	{
		outb((addr >> 1) & 0xff, ((dma & 3) << 2) + 0xc0);
		outb((addr >> 9) & 0xff, ((dma & 3) << 2) + 0xc0);
	}
}

/*    */
void set_dma_count(unsigned int dma, unsigned int count)
{
	if( dma <= 3 )
	{
		outb(count & 0xff, (dma << 1) + 0x01);
		outb((count >> 8) & 0xff, (dma << 1) + 0x01);
	}
	else
	{
		outb((count >> 1) & 0xff, ((dma & 3) << 2) + 0xc2);
		outb((count >> 9) & 0xff, ((dma & 3) << 2) + 0xc2);
	}
}
