/*    */
#include <boot.h>

/*   */
#define SELECTOR_CODE            8
/*   */
#define SELECTOR_DATA           16
/*   */
#define STECK_TOP         0x0a0000

.code16

.text
.globl _start
_start:
	/*   */
	cli
	/*   DS */
	xorw %ax,%ax
	movw %ax,%ds

	/*     */
	lgdt _gdtr
	movl %cr0,%eax
	orl $1,%eax
	movl %eax,%cr0
	ljmp $SELECTOR_CODE,$start_PM

.align 8,0
.code32
	/*    */
start_PM:
	/*
	 *   :
	 * SS, DS, ES
	 */
	movl $SELECTOR_DATA, %eax
	movw %ax, %ss
	movw %ax, %ds
	movw %ax, %es
	/*  FS, GS */
	xorw %ax,%ax
	movw %ax, %fs
	movw %ax, %gs

	/*    */
	movl $STECK_TOP, %esp

	/*   .bss  */
	xorl %eax, %eax
	movl $__bss, %edi
	movl $__ebss, %ecx
	subl %edi, %ecx
	shrl $0x02, %ecx
	cld
	rep stosl

	/*   IDTR */
	lidt _idtr

	/*      */
	call mm_init
	/*    */
	movl $page_dir, %eax
	movl %eax, %cr3
	movl %cr0, %eax
	orl $0x80000000, %eax
	movl %eax, %cr0
	jmp 1f

	/*   main */
1:	movl $main, %eax
	pushl %eax
	ret

	/*         */
1:	jmp 1b

_gdtr:
	.word 9*8-1
	.long gdt

_idtr:
	.word 49*8-1
	.long idt

.globl gdt
.align 8,0
gdt:
	.quad 0x0000000000000000
	.quad 0x00c09a00000000bf   /*   */
	.quad 0x00c09200000000bf   /*   */
	.fill 6,8,0                /*  TSS  LDT */
